local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local DT = E:GetModule('DataTexts');

local menuFrame = CreateFrame("Frame", "MaUIBerufe", E.UIParent, "UIDropDownMenuTemplate")
local menuList = {}

local function getProf(index)
	local name, icon, skillLevel, maxSkillLevel, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)

	return format (name .. " (" .. skillLevel .. "/" .. maxSkillLevel .. ")")
 end
 
local function castProf(index)
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine,
		skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)
		
	if name == GetSpellInfo(2575) then
		name = GetSpellInfo(2656)
	end
	
	CastSpellByName(name, self)
end

local function setupProf()
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	local mI = 1
	
	menuList = {}
	
	if (prof1 == nil) and (prof2 == nil) then
			tinsert(menuList, mI, {text = "Keine Hauptberufe", isTitle = true, notCheckable = true})
			mI = mI + 1
	else
		tinsert(menuList, mI, {text = "Hauptberufe", isTitle = true, notCheckable = true})
		mI = mI + 1
		
		if prof1 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof1), notCheckable = true, func = function() castProf(prof1) end})
			mI = mI + 1
		end
	
		if prof2 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof2), notCheckable = true, func = function() castProf(prof2) end})
			mI = mI + 1
		end
	end
	
	if  (archaeology == nil) and (cooking == nil) and (firstAid == nil) and (fishing == nil)  then
		tinsert(menuList, mI, {text = "Keine Nebenberufe", isTitle = true, notCheckable = true})
		mI = mI + 1
	else
		tinsert(menuList, mI, {text = "Nebenberufe", isTitle = true, notCheckable = true})
		mI = mI + 1
		
		if archaeology ~= nil then
			tinsert(menuList, mI, {text = getProf(archaeology), notCheckable = true, func = function() castProf(archaeology) end})
			mI = mI + 1
		end
		
		if cooking ~= nil then
			tinsert(menuList, mI, {text = getProf(cooking), notCheckable = true, func = function() castProf(cooking) end})
			mI = mI + 1
		end
		
		if firstAid ~= nil then
			tinsert(menuList, mI, {text = getProf(firstAid), notCheckable = true, func = function() castProf(firstAid) end})
			mI = mI + 1
		end
		
		if fishing ~= nil then
			tinsert(menuList, mI, {text = getProf(fishing), notCheckable = true})
			mI = mI + 1
		end
	end
end

local function OnEnter(self, ...)
	self.text:SetText("Berufe")
end

local function OnClick(self)
	setupProf()
	EasyMenu(menuList, menuFrame, "cursor", 0, 0, "MENU", 2)
end

--[[
	DT:RegisterDatatext(name, events, eventFunc, updateFunc, clickFunc, onEnterFunc, onLeaveFunc)

	name - name of the datatext (required)
	events - must be a table with string values of event names to register
	eventFunc - function that gets fired when an event gets triggered
	updateFunc - onUpdate script target function
	click - function to fire when clicking the datatext
	onEnterFunc - function to fire OnEnter
	onLeaveFunc - function to fire OnLeave, if not provided one will be set for you that hides the tooltip.]]

DT:RegisterDatatext('Berufe', nil, OnEnter, nil, OnClick)